'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                               DWM spinner                                |
'//|                                                                          |
'//|                      Composited spinner annimation                       |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                         Author Patrice TERRIER                           |
'//|                            copyright(c) 2014                             |
'//|                           www.zapsolution.com                            |
'//|                        pterrier@zapsolution.com                          |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                  Project started on : 01-05-2014 (MM-DD-YYYY)            |
'//|                        Last revised : 01-06-2014 (MM-DD-YYYY)            |
'//+--------------------------------------------------------------------------+

#COMPILE EXE "DWMspinner.exe"
#INCLUDE "WIN32API.INC"

%TIMER_DELAY   = 30
%TIMER_SPINNER = -1

%S_OK = 0
%WM_DWMCOMPOSITIONCHANGED     = &H031E
%DWM_BB_ENABLE                = &H00000001
%DWM_BB_BLURREGION            = &H00000002
%DWM_BB_TRANSITIONONMAXIMIZED = &H00000004
%DWM_EC_ENABLECOMPOSITION     = 1
%DWM_EC_DISABLECOMPOSITION    = 0

type DWM_BLURBEHIND
    dwFlags  as DWORD
    fEnable  as long
    hRgnBlur as DWORD
    fTransitionOnMaximized as long
end type

type GdiplusStartupInput
    GdiplusVersion           as DWORD
    DebugEventCallback       as DWORD
    SuppressBackgroundThread as long
    SuppressExternalCodecs   as long
end type

global ghImg, gn_DELAY, g_hDC, g_hBitmap, g_hMain, g_GDIPLIB as DWORD
global gn_W, gn_H, gn_FrameCount, gn_FrameToUse, gn_IsHorizontal as long

function Load_GDIPLUS() as long
    static nRet as long
    if (nRet = 0) then
       g_GDIPLIB = LoadLibrary ("GDIPLUS")
       if (g_GDIPLIB) then nRet = -1
    end if
    function = nRet
end function

function GdiplusStart (byref hGDIplus as DWORD, inputbuf as GdiplusStartupInput, byval outputbuf as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdiplusStartup")
        if (hPROC) then CALL DWORD hProc USING GdiplusStart(hGDIplus, inputbuf, outputbuf) TO nRet
    end if
    function = nRet
end function

function GdiplusShutdown (byval hGDIplus as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdiplusShutdown")
        if (hProc) then CALL DWORD hProc USING GdiplusShutdown(hGDIplus) TO nRet
    end if
    function = nRet
end function

function GdipLoadImageFromFile (szImgName as WSTRINGZ, byref lpImg as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    lpImg = 0
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipLoadImageFromFile")
        if (hProc) then CALL DWORD hProc USING GdipLoadImageFromFile(szImgName, lpImg) TO nRet 
    end if
    function = nRet
end function

function GdipDeleteGraphics(byval graphics as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipDeleteGraphics"):
        if (hProc) then CALL DWORD hProc USING GdipDeleteGraphics(graphics) TO nRet
    end if
    function = nRet
end function

function GdipDrawImageRectRectI(byval graphics as DWORD, byval lpImg as DWORD, byval dstX as long, byval dstY as long, byval dstW as long, byval dstH as long, byval srcX as long, byval srcY as long, byval srcW as long, byval srcH as long, _
                                byval srcUnit as long, byval imageattr as DWORD, byval lpCallback as DWORD, byval callbackdata as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipDrawImageRectRectI"):
        if (hProc) then CALL DWORD hProc USING GdipDrawImageRectRectI(graphics, lpImg, dstX, dstY, dstW, dstH, srcX, srcY, srcW, srcH, srcUnit, imageattr, lpCallback, callbackdata) TO nRet
    end if
    function = nRet
end function

function GdipDisposeImage(byval lpImg as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipDisposeImage")
        if (hProc) then CALL DWORD hProc USING GdipDisposeImage(lpImg) TO nRet
    end if
    function = nRet
end function

function GdipGetImageWidth(byval lpImg as DWORD, byref imgW as long) as long
    local nRet as long: nRet = -1 '// Error
    imgW = 0
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipGetImageWidth"):
        if (hProc) then CALL DWORD hProc USING GdipGetImageWidth(lpImg, imgW) TO nRet
    end if
    function = nRet
end function

function GdipGetImageHeight(byval lpImg as DWORD, byref imgH as long) as long
    local nRet as long: nRet = -1 '// Error
    imgH = 0
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipGetImageHeight"):
        if (hProc) then CALL DWORD hProc USING GdipGetImageHeight(lpImg, imgH) TO nRet
    end if
    function = nRet
end function

function GdipCreateFromHDC(byval hDC as DWORD, byref graphics as DWORD) as long
    local nRet as long: nRet = -1 '// Error
    graphics = 0
    if (g_GDIPLIB) then
        local hProc as DWORD: hProc = GetProcAddress(g_GDIPLIB, "GdipCreateFromHDC")
        if (hProc) then CALL DWORD hProc USING GdipCreateFromHDC(hDC, graphics) TO nRet
    end if
    function = nRet
end function

function gdiphandle(byval hGDIplus as DWORD, byval RW as long) as DWORD
    static wasHandle as DWORD
    if (RW) then wasHandle = hGDIplus
    function = wasHandle
end function

function GdipStart () as DWORD
    if (Load_GDIPLUS()) then
        '// Load the GDI+ Dll
        local GpInput as GdiplusStartupInput
        GpInput.GdiplusVersion = 1
        local hGDIplus as DWORD: hGDIplus = gdiphandle(0, 0)
        if (hGDIplus = 0) then
            if (GdiplusStart(hGDIplus, GpInput, %NULL) = 0) then
                gdiphandle(hGDIplus, 1)
            end if
        end if
    end if
    function = gdiphandle(0, 0)
end function

sub GdipEnd (byval hGDIplus as DWORD)
    if (hGDIplus) then GdiplusShutdown(hGDIplus)
end sub

function LoadDWM () as long
    static hLib as DWORD, nChecked as long
    if nChecked = 0 then nChecked = -1: hLib = LoadLibrary ("dwmapi.dll")
    function = hLib
end function

function zDwmEnableComposition (byval uCompositionAction as long) as long
    local nRet as long, hLib as DWORD
    static hProc as DWORD
    hLib = LoadDWM()
    if hLib then
       if hProc = 0 then hProc = GetProcAddress(hLib, "DwmEnableComposition")
       if hProc then
          CALL DWORD hProc USING zDwmEnableComposition(uCompositionAction) TO nRet
       end if
    end if
    function = nRet
end function

function zDwmIsCompositionEnabled () as long
    local nRet as long, hLib as DWORD
    static hProc as DWORD
    hLib = LoadDWM()
    if hLib then
       if hProc = 0 then hProc = GetProcAddress(hLib, "DwmIsCompositionEnabled")
       if hProc then
          CALL DWORD hProc USING zDwmIsCompositionEnabled() TO nRet
          if nRet then function = -1
       end if
    end if
end function

declare function DwmEnableBlurBehindWindow (byval DWORD, pBlurBehind as DWM_BLURBEHIND) as long
sub zSetCrystalBehindMode(byval hWnd as DWORD, byval nBOOL as long)
    local bb as DWM_BLURBEHIND
    local hLib as DWORD, nRet, hRgnBlur as long
    static hProc as DWORD
    hLib = LoadDWM ()
    if hLIB then
       if zDwmIsCompositionEnabled() then
          if hProc = 0 then hProc = GetProcAddress(hLib, "DwmEnableBlurBehindWindow")
          if hProc then
             nRet = %S_OK
             '// Create and populate the BlurBehind structure.
             '// Set Blur Behind and Blur Region.
             bb.fEnable = nBOOL
             bb.dwFlags = %DWM_BB_ENABLE OR %DWM_BB_BLURREGION
             bb.fTransitionOnMaximized = 0
             '// Fool VISTA with a fake region
             if nBOOL then hRgnBlur = CreateRectRgn(-1, -1, 0, 0)
             bb.hRgnBlur = hRgnBlur
             '// Set Blur Behind mode.
             CALL DWORD hProc USING DwmEnableBlurBehindWindow(hWnd, bb) TO nRet
          end if
       end if
    end if
end sub

function zCreateDIBSection(byval hDC as DWORD, byval nWidth as long, byval nHeight as long, byval nBitCount as WORD) as DWORD
    local bi as BITMAPINFO
    bi.bmiHeader.biSize = sizeof(bi.bmiHeader)
    bi.bmiHeader.biWidth = nWidth
    bi.bmiHeader.biHeight = -nHeight
    bi.bmiHeader.biPlanes = 1
    bi.bmiHeader.biBitCount = nBitCount
    bi.bmiHeader.biCompression = %BI_RGB
    function = CreateDIBSection(hDC, bi, %DIB_RGB_COLORS, %NULL, %NULL, %NULL)
end function

sub Animate (byval Delay as DWORD)
    local nWait as DWORD
    local nFrame as long
    local graphics as DWORD
    local r as RECT
    local lp as POINTAPI
    local lpSize as SIZEL
    GetWindowRect(g_hMain, r):
    lpSize.cx = r.right - r.left: lpSize.cy = r.bottom - r.top
    lp.x = r.left: lp.y = r.top
    SetRect(r, 0, 0, lpSize.cx, lpSize.cy)
    local hBrush as DWORD
    do
        if (IsWindowVisible(g_hMain)) then
            if (ghImg) then
                if (g_hBitmap = 0) then
                    local DesktopDC as DWORD: DesktopDC = GetDC(0)
                    g_hDC = CreateCompatibleDC(DesktopDC)
                    g_hBitmap = zCreateDIBSection(g_hDC, lpSize.cx, lpSize.cy, 32)
                    SelectObject(g_hDC, g_hBitmap)
                    ReleaseDC(0, DesktopDC)
                end if
                if (g_hBitmap) then

                    '// Create a null brush, to clear the background of our permanent bitmap.
                    hBrush = CreateSolidBrush(%NULL)
                    SelectObject(g_hDC, hBrush)
                    FillRect(g_hDC, r, hBrush)
                    DeleteObject(hBrush)

                    if (GdipCreateFromHDC(g_hDC, graphics) = 0) then
                        gn_FrameToUse += 1: if (gn_FrameToUse > gn_FrameCount) then gn_FrameToUse = 1
                        if (ghImg) then
                            if (gn_IsHorizontal) then
                                GdipDrawImageRectRectI(graphics, ghImg, 0, 0, gn_H, gn_H, gn_H * gn_FrameToUse - gn_H, 0, gn_H, gn_H, 2, 0, %NULL, %NULL)
                            else
                                GdipDrawImageRectRectI(graphics, ghImg, 0, 0, gn_W, gn_W, gn_W * gn_FrameToUse - gn_W, 0, gn_W, gn_W, 2, 0, %NULL, %NULL)
                            end if
                        end if
                        GdipDeleteGraphics(graphics)
                    end if

                    '// Warning we use a permanent DC (%CS_OWNDC)
                    BitBlt(GetDC(g_hMain), 0, 0, lpSize.cx, lpSize.cy, g_hDC, 0, 0, %SRCCOPY)

                end if
            end if
        end if

        apiSLEEP(gn_DELAY)
    loop
end sub

function StartAnimation (byval Delay as DWORD) as long
    local nRet as long: nRet = %LB_ERR
    gn_DELAY = Delay
    local hThread, dwThreadId as DWORD
    hThread = CreateThread(byval %NULL, _         '// default security attributes
                           0, _                   '// use default stack size  
                           CODEPTR(Animate), _    '// thread function name
                           Delay, _               '// argument to thread function 
                           0, _                   '// use default creation flags 
                           dwThreadId)            '// returns the thread identifier
    if (hThread) then nRet = 0: apiSLEEP(100)
    CloseHandle(hThread)
    function = nRet
end function

sub SpinnerInit (byval hParent as DWORD, byval hWnd as DWORD, szFileName as WSTRINGZ, byval nSpeedDelay as long)

    if (IsWindow(hParent) = 0) then hParent = GetDesktopWindow()

    gn_FrameCount = 0
    if (ghImg) then GdipDisposeImage(ghImg): ghImg = 0

    if (GdipLoadImageFromFile(szFileName, ghImg) = 0) then
        GdipGetImageWidth(ghImg, gn_W)
        GdipGetImageHeight(ghImg, gn_H)
        if (gn_W > gn_H) then
            gn_FrameCount = gn_W \ gn_H
            gn_IsHorizontal = -1
        else
            gn_FrameCount = gn_H \ gn_W
            gn_IsHorizontal = 0
        end if

        local r as RECT: GetWindowRect(hParent, r)
        MoveWindow(hWnd, r.nleft + ((r.right - r.left - gn_H) \ 2), r.top + ((r.bottom - r.top - gn_H) \ 2), gn_H, gn_H, 0)

        if (zDwmIsCompositionEnabled()) then
            zSetCrystalBehindMode(hWnd, %TRUE)
        end if
        
        if (nSpeedDelay = 0) then
            if (gn_FrameCount < 4) then
                gn_DELAY = 75
            elseif (gn_FrameCount < 8) then
                gn_DELAY = 50
            elseif (gn_FrameCount < 12) then
                gn_DELAY = 37
            else
                gn_DELAY = %TIMER_DELAY
            end if
        end if

        g_hMain = hWnd: StartAnimation(gn_DELAY)

    end if
end sub

function SpinnerProc (byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as long, byval lParam as long) as long
    select case long (uMsg)
    case %WM_KEYDOWN:
         if (wParam = %VK_ESCAPE) then DestroyWindow(hWnd)

    case %WM_NCHITTEST:
         function = %HTCAPTION: exit function

    case %WM_DESTROY:
         if (g_hBitmap) then DeleteObject(g_hBitmap)
         if (g_hDC) then DeleteDC(g_hDC)
         KillTimer(hWnd, %TIMER_SPINNER)
         PostQuitMessage(0)
         if (ghImg) then GdipDisposeImage(ghImg): ghImg = 0
         function = 0: exit function
    end select
    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

function WinMain (byval hInstance as DWORD, byval hPrevInstance AS DWORD, _
                  byval lpCmdLine as WSTRINGZ PTR, byval iCmdShow as long) as long
    local hWnd, hParent as DWORD
    local nRet, nSpeedDelay as long
    local msg as tagMSG
    local wcx as WNDCLASSEX
    local szClassName as WSTRINGZ * 16: szClassName = "ZSPIN_DWM32"
    local szFileName as WSTRINGZ * %MAX_PATH

    wcx.cbSize = sizeof(wcx):
    local IsInitialized as long: IsInitialized = GetClassInfoExW(hInstance, szClassName, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_OWNDC
        wcx.lpfnWndProc   = CODEPTR(SpinnerProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInstance
        wcx.hIcon         = %NULL
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %NULL
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = VARPTR(szClassName)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassExW(wcx)) then IsInitialized = -1
    end if

    if (IsInitialized) then
        hWnd = CreateWindowExW(%WS_EX_TOOLWINDOW OR %WS_EX_TOPMOST, szClassName, szClassName, %WS_POPUP OR %WS_VISIBLE, _
                               0, 0, 0, 0, %NULL, %NULL, hInstance, byval %NULL)
        if (hWnd) then
            local hGDIplus as DWORD
            'szFileName = lpCmdLine
            MEMORY COPY lpCmdLine, VARPTR(szFileName), sizeof(szFileName)
            if (IsFile(szFileName)) then
                hGDIplus = GdipStart(): if (hGDIplus) then SpinnerInit (hParent, hWnd, szFileName, nSpeedDelay)
            end if
            if (hGDIplus = 0) then DestroyWindow(hWnd)

            UpdateWindow(hWnd)

            while (GetMessage(msg, %NULL, 0, 0))
                TranslateMessage(msg)
                DispatchMessage(msg)
            wend

            if (hGDIplus) then GdipEnd(hGDIplus)
            nRet = msg.wParam
        end if
    end if
    function = nRet
end function
 